<?php
require_once __DIR__ . '/../../../init.php';
App::load_function('gateway');
App::load_function('invoice');

// Detect module name from filename.
$gatewayModuleName = basename(__FILE__, '.php');

// Fetch gateway configuration parameters.
$gatewayParams = getGatewayVariables($gatewayModuleName);

// Die if module is not active.
if (!$gatewayParams['type']) {
	die('Module Not Activated');
}

logTransaction($gatewayParams['name'], $_POST, 'Check params');

$invoice = filter_input(INPUT_POST, 'merchant_id');
$invoice_id = explode('-', $invoice);
$invoice_id = $invoice_id[0];

$invoice_id = checkCbInvoiceID($invoice_id, $gatewayParams['name']);

$trans_id = filter_input(INPUT_POST, 'intid');
checkCbTransID($trans_id);

$sum = filter_input(INPUT_POST, 'amount');
$sign_2 = filter_input(INPUT_POST, 'sign_2');

$merchant_id = $gatewayParams['merchant_id'];
$secret_word2 = $gatewayParams['secret_word2'];

$sign = md5($merchant_id.':'.$sum.':'.$secret_word2.':'.$invoice);

if ($sign == $sign_2) {
	addInvoicePayment($invoice_id, $trans_id, 0, 0, $gatewayModuleName);
} else {
	logTransaction($gatewayParams['name'], 'Hash signature does not match', 'Failure');
}