<?php
if (!defined("WHMCS")) {
	die("This file cannot be accessed directly");
}

/**
 * Define module related meta data.
 *
 * Values returned here are used to determine module related capabilities and
 * settings.
 *
 * @see https://developers.whmcs.com/payment-gateways/meta-data-params/
 *
 * @return array
 */
function enot_MetaData() {
	return array(
		'DisplayName' => 'Enot Merchant Gateway Module',
		'APIVersion' => '1.1', // Use API Version 1.1
		'DisableLocalCredtCardInput' => true,
		'TokenisedStorage' => false,
	);
}

/**
 * Define gateway configuration options.
 *
 * The fields you define here determine the configuration options that are
 * presented to administrator users when activating and configuring your
 * payment gateway module for use.
 *
 * Supported field types include:
 * * text
 * * password
 * * yesno
 * * dropdown
 * * radio
 * * textarea
 *
 * Examples of each field type and their possible configuration parameters are
 * provided in the sample function below.
 *
 * @see https://developers.whmcs.com/payment-gateways/configuration/
 *
 * @return array
 */
function enot_config() {
	return array(
		// the friendly display name for a payment gateway should be
		// defined here for backwards compatibility
		'FriendlyName' => array(
			'Type' => 'System',
			'Value' => 'Enot',
		),
		'merchant_id' => array(
			'FriendlyName' => 'ID магазина',
			'Type' => 'text',
			'Size' => '25',
			'Default' => '',
			'Description' => '',
		),
		'secret_word' => array(
			'FriendlyName' => 'Секретный пароль',
			'Type' => 'text',
			'Size' => '25',
			'Default' => '',
			'Description' => '',
		),
		'secret_word2' => array(
			'FriendlyName' => 'Дополнительный ключ',
			'Type' => 'text',
			'Size' => '25',
			'Default' => '',
			'Description' => '',
		),
	);
}

/**
 * Payment link.
 *
 * Required by third party payment gateway modules only.
 *
 * Defines the HTML output displayed on an invoice. Typically consists of an
 * HTML form that will take the user to the payment gateway endpoint.
 *
 * @param array $params Payment Gateway Module Parameters
 *
 * @see https://developers.whmcs.com/payment-gateways/third-party-gateway/
 *
 * @return string
 */
function enot_link($params) {
	$merchant_id = $params["merchant_id"];
	$secret_word = $params["secret_word"];

	$sum = $params['amount'];

	$invoice = $params['invoiceid'].'-'.time();

	$form_params = array(
		'm' => $merchant_id,
		'oa' => $sum,
		'cr' => $params['currency'],
		'o' => $invoice,
		'c' => $params['description'],
		's' => md5($merchant_id.':'.$sum.':'.$secret_word.':'.$invoice),
	);

	$inputs = '';
	foreach ($form_params as $key => $value) {
		$inputs .= '<input type="hidden" name="'.$key.'" value="'.$value.'">';
	}

	return '<form method="GET" action="https://enot.io/_/pay">'.$inputs.'<input type="submit" value="'.$params['langpaynow'].'"></form>';
}